// -------------- Component Templating --------------------
//_.templateSettings = {
//	interpolate : /\{\{(.+?)\}\}/g
//};
var DEFAULT_FONT_SIZE = 16;
var DEFAULT_BASE_COMP_PROP = {
	'navigation' : ''
};
// Text Component
textTemplate = _
		.template('<div style="color:<%=color%>;overflow-x:hidden;overflow-y:auto;font-size:<%=textSize%>px;font-family:<%=fontFamily%>;height:<%=textHeight%>;-webkit-border-radius: <%=roundCorner%>px;'
				+ '<%=bgColorStyle%>;background-image:url(\'<%=bgImageUrl%>\');background-size:100% 100%;text-align:<%=align%>;font-style:<%=style%>;font-weight:<%=weight%>;padding:<%=padding%>px;"><%=text%></div>');
DEFAULT_TEXT_COMP_PROP = _.extend({}, DEFAULT_BASE_COMP_PROP, {
	'text' : '请加入文本',
	'color' : 'black',
	'textSize' : 12,
	'fontFamily' : '',
	'bgImageUrl' : '',
	'bgColorStyle' : '',
	'align' : 'left',
	'style' : 'normal',
	'weight' : 'normal',
	'padding' : 5,
	'roundCorner' : 0
});
// Rich Component
richTemplate = _.template('<div style="overflow-x:hidden;overflow-y:auto;height:<%=textHeight%>;-webkit-border-radius: <%=roundCorner%>px;'
		+ '<%=bgColorStyle%>;background-image:url(\'<%=bgImageUrl%>\');background-size:100% 100%;padding:<%=padding%>px;"><%=text%></div>');
DEFAULT_RICH_COMP_PROP = _.extend({}, DEFAULT_BASE_COMP_PROP, {
	'text' : '请加入文本',
	'bgImageUrl' : '',
	'bgColorStyle' : '',
	'padding' : 5,
	'roundCorner' : 0
});
// Image Component
imageTemplate = _.template('<img src="<%=imageUrl%>" style="width:100%;height:100%;-webkit-border-radius: <%=roundCorner%>px;">');
DEFAULT_IMAGE_COMP_PROP = _.extend({}, DEFAULT_BASE_COMP_PROP, {
	'imageUrl' : '',
	'roundCorner' : 0
});
// NavTop Component
navTopTemplate = _
		.template('<table style="width:100%;height:100%;text-align:center;vertical-align:middle;<%=bgColorStyle%>;background-image:url(\'<%=bgImageUrl%>\');background-size:100% 100%;">'
				+ '<col width="25%">'
				+ '<col width="50%">'
				+ '<col width="25%">'
				+ '<tr>'
				+ '<td class="pre" style="background-image:url(\'<%=preImageUrl%>\');background-size:65% auto;background-repeat:no-repeat;background-position:center;color:<%=preTextColor%>;font-size:<%=preTextSize%>px;">'
				+ '<%=preText%>'
				+ '</td>'
				+ '<td class="pageTitle" style="color:<%=titleTextColor%>;font-size:<%=titleTextSize%>px;">'
				+ '<%=titleText%>'
				+ '</td>'
				+ '<td class="next" style="background-image:url(\'<%=nextImageUrl%>\');background-size:65% auto;background-repeat:no-repeat;background-position:center;color:<%=nextTextColor%>;font-size:<%=nextTextSize%>px;">'
				+ '<%=nextText%>' + '</td>' + '</tr>' + '</table>');
DEFAULT_NAVTOP_COMP_PROP = _.extend({}, {
	'preImageUrl' : '',
	'preTextColor' : 'black',
	'preTextSize' : 12,
	'preText' : '返回',
	'nextImageUrl' : '',
	'nextTextColor' : 'black',
	'nextTextSize' : 12,
	'nextText' : '',
	'titleTextColor' : 'black',
	'titleTextSize' : 12,
	'titleText' : '...',
	'bgImageUrl' : '',
	'bgColor' : 'skyblue',
	'bgColorStyle' : ''
});
// List Component
listTemplate = _
		.template('<div style="padding:<%=padding%>px;overflow-x:hidden;overflow-y:auto;width:<%=textWidth%>px;height:<%=textHeight%>;text-align:center;vertical-align:middle;<%=bgColorStyle%>;background-image:url(\'<%=bgImageUrl%>\');background-size:100% 100%;-webkit-border-radius: <%=roundCorner%>px;">'
				+ '<%=listDom%>' + '</div>');
listDividerTemplate = _
		.template('<div style="position:relative;overflow:hidden;width:100%;height:<%=divHeight%>px;<%=divColorStyle%>;background-image:url(\'<%=divImageUrl%>\');background-size:100% 100%;"></div>');
DEFAULT_LIST_COMP_PROP = _.extend({}, {
	'bgImageUrl' : '',
	'bgColorStyle' : '',
	'divImageUrl' : '',
	'divColor' : 'silver',
	'divHeight' : 20,
	'roundCorner' : 0,
	'rowRoundCorner' : 0,
	'padding' : 10
});

// FONT-FACE css
fontCssTemplate = _
		.template('<style id="fontFamily<%=family%>">@font-face {font-family: "<%=family%>";src: url("<%=file%>") format("<%=format%>");font-weight: normal;font-style: normal;}</style>');
DEFAULT_APP_FONT_FAMILY = 'appDefault';
FONT_ANDROID_SYSTEM = {
	'name' : '(安卓系统自带)',
	'family' : 'sans-serif',
	'system' : true
};
allCustomFonts = [ {
	'name' : '造字工房悦黑',
	'family' : 'MFYueHei',
	'sample' : '/static/font/MFYueHei.png',
	'file' : '/static/font/MFYueHei.otf',
	'format' : 'opentype',
	'size' : '1.4MB'
}, {
	'name' : '造字工房雅圆',
	'family' : 'MFYaYuan',
	'sample' : '/static/font/MFYaYuan.png',
	'file' : '/static/font/MFYaYuan.otf',
	'format' : 'opentype',
	'size' : '2.5MB'
}, {
	'name' : '造字工房情书',
	'family' : 'MFQingShu',
	'sample' : '/static/font/MFQingShu.png',
	'file' : '/static/font/MFQingShu.otf',
	'format' : 'opentype',
	'size' : '4.2MB'
}, {
	'name' : '华文行楷',
	'family' : 'huawenxingkai',
	'sample' : '/static/font/huawenxingkai.png',
	'file' : '/static/font/huawenxingkai.otf',
	'format' : 'opentype',
	'size' : '4.7MB'
}, {
	'name' : '文鼎PL简中楷',
	'family' : 'wendingjianzhongkai',
	'sample' : '/static/font/wendingjianzhongkai.png',
	'file' : '/static/font/wendingjianzhongkai.otf',
	'format' : 'opentype',
	'size' : '4.8MB'
}, {
	'name' : '新蒂黑板报体',
	'family' : 'SentyChalk',
	'sample' : '/static/font/SentyChalk.png',
	'file' : '/static/font/SentyChalk.otf',
	'format' : 'opentype',
	'size' : '7.1MB'
} ];

ANDROID_ASSET_ROOT = 'file:///android_asset/anthology/';

var $root, $currentPage, pageRootDoms = [];
var winWidth, winHeight, r;
// var historyStack = [];
var SLIDE_DURATION = 200;

var pageTree, flattenPageTree;
var navMap = {}; // {to-page-id:from-page-id}

$(document).ready(function() {

	// console.log("######################### app ready!!!");

	winWidth = $(window).width();
	// console.log("winWidth=" + winWidth);
	winHeight = $(window).height();
	// console.log("winHeight=" + winHeight);
	r = winWidth * 1.0 / 360;
	// console.log("r=" + r);
	// console.log(navigator.userAgent);

	$root = $('.contentRoot');

	// handle font-face css loading
	processFonts();

	pageTree = appData.pageTree;
	flattenPageTree = _.flatten(getPageTreeArray(pageTree[0], null));
	// console.log('flattenPageTree=' + JSON.stringify(flattenPageTree));

	var pages = appData.pages;
	_.each(flattenPageTree, function(pageTreeNode) {
		if (pageTreeNode.id == 'root') {
			return;
		}
		var page = _.findWhere(appData.pages, {
			'id' : pageTreeNode.id
		});
		page.children = pageTreeNode.children;
		page.parent = pageTreeNode.parent;
		createPage(page);
	});

	navigateTo('root', flattenPageTree[1].id); // skip root
});

var getPageTreeArray = function(node, parent) {
	if (parent) {
		node.parent = parent.id;
	}
	return [ node, _.map(node.children, function(childNode) {
		return getPageTreeArray(childNode, node);
	}) ];
}

function createPage(page) {

	var $pageRoot = $('<div class="page" id="' + page.id + '"></div>');
	$pageRoot.attr({
		'm-page-id' : page.id,
	});
	$pageRoot.css({
		'font-size' : DEFAULT_FONT_SIZE * r + 'px'
	});
	$pageRoot.height(winHeight);

	// Nav Top
	var compNavTop, navTopHeight = 0;
	compNavTop = _.findWhere(page.components, {
		'type' : 'navTop'
	});
	if (compNavTop) {
		var $pageTop = $('<div class="pageTop"></div>');
		$pageTop.appendTo($pageRoot);
		var $navTop = createNavTop(compNavTop, page);
		$navTop.appendTo($pageTop);
		navTopHeight = compNavTop.prop.size.height * r;
	}

	// Main
	var $pageMain = $('<div class="pageMain"></div>');
	if (page.prop.bgImageUrl) {
		$pageMain.css({
			'background-image' : 'url(' + convertAssetUrl2AndroidEmbedUrl(page.prop.bgImageUrl) + ')',
			'background-size' : '100% 100%'
		});
	} else if (page.prop.bgColor) {
		$pageMain.css({
			'background-color' : page.prop.bgColor
		});
	}
	if (compNavTop) {
		// create empty NavTop placeHolder to avoid absolute position approach
		// var $navTopPlaceHolder = $('<div style="position:relative;width:' +
		// winWidth + 'px;height:' + navTopHeight
		// + 'px;"></div>');
		// $navTopPlaceHolder.appendTo($pageMain);

	}

	// create contents placeHolder for scrolling purpose
	var $contentsPlaceHolder = $('<div class="contentsPlaceHolder" style="position:relative;width:' + winWidth + 'px;height:' + (winHeight - navTopHeight)
			+ 'px;"></div>');
	// console.log("$contentsPlaceHolder is set with height: " + (winHeight -
	// navTopHeight));
	$contentsPlaceHolder.appendTo($pageMain);

	// create contents placeHolder for scrolling purpose
	// var holderHeight = (winHeight - navTopHeight);
	// var contentsHeight = page.prop.mainHeight * r;
	// if (holderHeight < contentsHeight) {
	// holderHeight = contentsHeight;
	// }
	// console.log('ZZZ holder height='+holderHeight);
	// var $contentsPlaceHolder = $('<div class="contentsPlaceHolder"
	// style="position:relative;width:' + winWidth + 'px;height:' + holderHeight +
	// 'px;"></div>');
	// // console.log("$contentsPlaceHolder is set with height: " + (winHeight -
	// // navTopHeight));
	// $contentsPlaceHolder.appendTo($pageMain);

	// adding components
	_.each(page.components, function(comp) {
		if (comp.type == 'navTop') {
			return;
		}
		var $comp = createComp(comp, page);
		$comp.appendTo($pageMain);
	});
	$pageMain.css({
		// 'position' : 'absolute',
		// 'top' : navTopHeight,
		'margin-top' : navTopHeight,
		'width' : winWidth,
		'height' : 'auto'
	});

	// Swipe, Scroll
	$pageMain.swipe({

		// 'allowPageScroll' : 'vertical',

		// Generic swipe handler for all directions
		'swipeLeft' : function(event, direction, distance, duration, fingerCount, fingerData) {
			// console.log("You swiped " + direction);
			var rightPage;
			_.find(flattenPageTree, function(node, idx) {
				if (node.id == page.id && idx < flattenPageTree.length - 1) {
					rightPage = flattenPageTree[idx + 1].id;
					return true;
				}
			});
			if (rightPage) {
				doPageTransit(rightPage, 'right2left');
			}
		},

		'swipeRight' : function(event, direction, distance, duration, fingerCount, fingerData) {
			// console.log("You swiped " + direction);
			var parentPage = _.findWhere(flattenPageTree, {
				'id' : page.parent
			});
			var siblingIndex;
			_.find(parentPage.children, function(node, idx) {
				if (node.id == page.id) {
					siblingIndex = idx;
					return true;
				}
			});
			var leftPage = (siblingIndex == 0 ? page.parent : parentPage.children[siblingIndex - 1].id);
			if (leftPage && leftPage != 'root') {
				doPageTransit(leftPage, 'left2right');
			}
		}
	});

	// $pageRoot.data('sysMainHeight', page.prop.mainHeight * r);
	// console.log('ZZZ r=' + r);
	// console.log('ZZZ page.prop.mainHeight=' + page.prop.mainHeight);
	// console.log('ZZZ final sysMainHeight=' + $pageRoot.data('sysMainHeight'));

	$pageMain.appendTo($pageRoot);
	$pageRoot.data('navTopHeight', navTopHeight);

	pageRootDoms.push($pageRoot);
	// console.log('adding page......' + $pageRoot.attr('m-page-id'));
}

function createNavTop(comp, page) {
	var prop, html;
	prop = _.extend({}, DEFAULT_NAVTOP_COMP_PROP, comp.prop);
	prop.preImageUrl = convertAssetUrl2AndroidEmbedUrl(prop.preImageUrl);
	prop.nextImageUrl = convertAssetUrl2AndroidEmbedUrl(prop.nextImageUrl);
	prop.bgImageUrl = convertAssetUrl2AndroidEmbedUrl(prop.bgImageUrl);
	prop.titleText = page.prop.title;
	prop.bgColorStyle = (prop.bgImageUrl || !prop.bgColor) ? '' : 'background-color:' + prop.bgColor;
	prop.preTextSize = prop.preTextSize * r;
	prop.nextTextSize = prop.nextTextSize * r;
	html = navTopTemplate(prop);

	var $comp = $('<div>' + html + '</div>');
	$comp.css({
		'width' : winWidth,
		'height' : comp.prop.size.height * r
	});
	var $pre = $comp.find('.pre');
	$pre.on('click', function(e) {
		navigateBack(page.id);
	});
	var $next = $comp.find('.next');
	$next.attr({
		'm-comp-navigation' : prop.navigation
	});
	$next.on('click', function(e) {
		var $ele = $(this);
		var navigationPageId = $ele.attr('m-comp-navigation');
		navigateTo(page.id, navigationPageId);
	});
	return $comp;
}

function createComp(comp, page, returnHtml) {

	var prop, html;
	if (comp.type == 'text') {

		prop = _.extend({}, DEFAULT_TEXT_COMP_PROP, comp.prop);
		if (prop.dataBindingProperty) {
			prop.text = page.prop[prop.dataBindingProperty];
		}
		prop.textWidth = prop.size.width * r;
		prop.textHeight = prop.autoHeight ? 'auto' : prop.size.height * r + 'px';
		prop.bgImageUrl = convertAssetUrl2AndroidEmbedUrl(prop.bgImageUrl);
		prop.bgColorStyle = (prop.bgImageUrl || !prop.bgColor) ? '' : 'background-color:' + prop.bgColor;
		prop.textSize = prop.textSize * r;
		if (!prop.text) {
			prop.text = '';
		}
		prop.id = comp.id;
		html = textTemplate(prop);

	} else if (comp.type == 'rich') {

		prop = _.extend({}, DEFAULT_RICH_COMP_PROP, comp.prop);
		if (prop.dataBindingProperty) {
			prop.text = page.prop[prop.dataBindingProperty];
		}
		prop.textWidth = prop.size.width * r;
		prop.textHeight = prop.autoHeight ? 'auto' : prop.size.height * r + 'px';
		prop.bgImageUrl = convertAssetUrl2AndroidEmbedUrl(prop.bgImageUrl);
		prop.bgColorStyle = (prop.bgImageUrl || !prop.bgColor) ? '' : 'background-color:' + prop.bgColor;
		if (!prop.text) {
			prop.text = '';
		}
		prop.id = comp.id;
		html = richTemplate(prop);

	} else if (comp.type == 'image') {

		prop = _.extend({}, DEFAULT_IMAGE_COMP_PROP, comp.prop);
		// data binding
		if (prop.dataBindingProperty) {
			prop.imageUrl = page.prop[prop.dataBindingProperty];
		}
		prop.imageUrl = convertAssetUrl2AndroidEmbedUrl(prop.imageUrl);
		html = imageTemplate(prop);

	} else if (comp.type == 'list') {

		prop = comp ? comp.prop : null;
		prop = _.extend({}, DEFAULT_LIST_COMP_PROP, prop);
		prop.padding = prop.padding * r;
		prop.roundCorner = prop.roundCorner * r;
		prop.textWidth = prop.size.width * r - 2 * prop.padding;
		prop.textHeight = prop.autoHeight ? 'auto' : prop.size.height * r + 'px';
		prop.bgImageId = convertAssetUrl2AndroidEmbedUrl(prop.bgImageId);
		prop.bgColorStyle = (prop.bgImageUrl || !prop.bgColor) ? '' : 'background-color:' + prop.bgColor;

		prop.listDom = createListRowDom(comp, page);
		html = listTemplate(prop);
	}

	if (returnHtml) {
		return html;
	}

	var $comp = $('<div>' + html + '</div>');
	$comp.css({
		'position' : 'absolute',
		'top' : prop.position.top * r,
		'left' : prop.position.left * r,
		'width' : prop.size.width * r,
		'height' : prop.autoHeight ? 'auto' : prop.size.height * r + 'px',
		'overflow' : 'auto',
		'z-index' : prop.layer
	});

	if (comp.type == 'rich' && r !== 1.0) {
		$comp.find('img').each(function(index, img) {
			var $img = $(img), assetId = $img.attr('m-asset-id');
			var imgWidth = parseInt($img.attr('width')), imgHeight = parseInt($img.attr('height'));
			if (imgWidth) {
				$img.width(imgWidth * r);
			}
			if (imgHeight) {
				$img.height(imgHeight * r);
			}
			if (!imgWidth && !imgHeight) {
				var asset = _.findWhere(appAssets, {
					'_id' : assetId
				});
				if (asset) {
					$img.width(asset.width * r);
				}
			}
		});
		$comp.find('span').each(function(index, span) {
			var $span = $(span), fontSize = parseInt($span.css('font-size'));
			// console.log('font-size:' + fontSize);
			if (fontSize) {
				$span.css('font-size', fontSize * r);
			}
		});
	}

	if (comp.type == 'text' || comp.type == 'rich' || comp.type == 'image') {
		$comp.attr({
			'm-comp-navigation' : prop.navigation
		});
		$comp.on('click', function(e) {
			var $ele = $(this);
			var navigationPageId = $ele.attr('m-comp-navigation');
			if (navigationPageId) {
				navigateTo(page.id, navigationPageId);
			}
		});
	}
	return $comp;
}

var createListRowDom = function(comp, page) {
	var listDom = '', prop = comp.prop;
	var rowHeight = prop.rowHeight * r + 'px';
	var rowBgImageUrl = convertAssetUrl2AndroidEmbedUrl(prop.rowBgImageUrl);
	var rowBgColorStyle = (rowBgImageUrl || !prop.rowBgColor) ? '' : 'background-color:' + prop.rowBgColor;
	prop.divImageUrl = convertAssetUrl2AndroidEmbedUrl(prop.divImageUrl);
	prop.divColorStyle = (prop.divImageUrl || !prop.divColor) ? '' : 'background-color:' + prop.divColor;

	_.each(page.children, function(childPage, pageIndex) {

		childPage = _.findWhere(appData.pages, {
			'id' : childPage.id
		});
		listDom = listDom + '<div class="listItem" style="position:relative;overflow:hidden;height:' + rowHeight + ';' + rowBgColorStyle
				+ ';background-image:url(\'' + rowBgImageUrl + '\');background-size:100% 100%;-webkit-border-radius: ' + prop.rowRoundCorner * r + 'px;" '
				+ ' m-page-id="' + page.id + '" m-comp-navigation="' + childPage.id + '">';
		_.each(comp.components, function(c) {
			var p = c.prop;
			rowDom = '<div style="position:absolute;top:' + p.position.top * r + 'px;left:' + p.position.left * r + 'px;width:' + p.size.width * r + 'px;height:'
					+ (p.autoHeight ? 'auto' : (p.size.height * r + 'px')) + ';z-index:' + p.layer + ';">' + createComp(c, childPage, true) + '</div>';
			listDom = listDom + rowDom;
		});
		listDom = listDom + '</div>';

		if (pageIndex < page.children.length - 1) {
			listDom = listDom + listDividerTemplate(prop);
		}
	});

	return listDom;
};

function navigateTo(fromPageId, nextPageId) {
	// console.log('navigating to....from: ' + fromPageId + ' to:' + nextPageId);
	if (!nextPageId) {
		return;
	}

	// if ($currentPage) {
	// var currentPageId = $currentPage.attr('m-page-id');
	// historyStack.push(currentPageId);
	// }
	navMap[nextPageId] = fromPageId;

	doPageTransit(nextPageId, 'right2left');
}

function navigateBack(currentPageId) {
	// console.log('navigating back from :' + currentPageId);
	var previousPageId;
	// first, try parent page
	var page = _.findWhere(flattenPageTree, {
		'id' : currentPageId
	});
	if (page.parent != 'root') {
		previousPageId = page.parent;
	} else {
		// secondly, try navMap page for manual direct navigation
		previousPageId = navMap[currentPageId];
		if (!previousPageId) {
			// lastly, try left-page
			var parentPage = _.findWhere(flattenPageTree, {
				'id' : page.parent
			});
			var siblingIndex;
			_.find(parentPage.children, function(node, idx) {
				if (node.id == page.id) {
					siblingIndex = idx;
					return true;
				}
			});
			var previousPageId = (siblingIndex == 0 ? page.parent : parentPage.children[siblingIndex - 1].id);
		} else {
			delete navMap[previousPageId];
		}
	}
	if (!previousPageId || previousPageId == 'root') {
		return;
	}

	doPageTransit(previousPageId, 'left2right');
}

function doPageTransit(targetPageId, dir) {

	// console.log('doPageTransit : ' + targetPageId);
	var sliding;
	if (dir == 'right2left') {
		sliding = {
			currentSlideOutTo : '-' + winWidth + 'px',
			targetSlideInFrom : winWidth + 'px'
		}
	} else if (dir == 'left2right') {
		sliding = {
			currentSlideOutTo : winWidth + 'px',
			targetSlideInFrom : '-' + winWidth + 'px'
		}
	}

	var $targetPage = _.find(pageRootDoms, function(p) {
		return p.attr('m-page-id') == targetPageId;
	});

	// slide out current page
	if ($currentPage) {
		var $oldCurrentPage = $currentPage;
		$currentPage.css({
			'position' : 'absolute'
		});
		$currentPage.animate({
			'left' : sliding.currentSlideOutTo
		}, {
			'duration' : SLIDE_DURATION,
			'easing' : 'swing',
			'complete' : function() {
				$oldCurrentPage.hide();
			}
		});
	}
	$currentPage = $targetPage;

	// slide in target page
	$targetPage.css({
		'position' : 'relative',
		'left' : sliding.targetSlideInFrom
	});
	if (!$.contains(document, $targetPage[0])) {
		$targetPage.appendTo($root);
		// list item navigation
		$targetPage.find('.listItem').on('click', function(e) {
			var $ele = $(this);
			var pageId = $ele.attr('m-page-id');
			var navigationPageId = $ele.attr('m-comp-navigation');
			if (navigationPageId) {
				navigateTo(pageId, navigationPageId);
			}
		});
	} else {
		$targetPage.show();
	}
	$targetPage.animate({
		'left' : '0px'
	}, {
		'duration' : SLIDE_DURATION
	});

	_.delay(function() {
		if (!$targetPage.data('mainHeight')) {
			var components = $targetPage.find('.pageMain').children();
			var HHH = winHeight - $targetPage.data('navTopHeight'), H = 0;
			_.each(components, function(c, idx) {
				var H = $(c).position().top + $(c).outerHeight(false);
				// console.log('#' + idx + " : " + H);
				if (H > HHH) {
					HHH = H;
				}
			});
			// console.log('HHH : ' + HHH);
			$targetPage.data('mainHeight', HHH);
		}
		// $ttt.height($targetPage.data('mainHeight') + 5);
		// $ttt.find('.pageMain').height($targetPage.data('mainHeight') + 10);
		// $targetPage.height(winHeight);
		// $targetPage.height(winHeight);
		$targetPage.find('.pageMain > .contentsPlaceHolder').height($targetPage.data('mainHeight'));
	}, 50);

	// if (!navigator.userAgent.match(/android 2/i)) {
	// // $targetPage.height(winHeight + 5);
	// $targetPage.find('.pageMain').height(winHeight -
	// $targetPage.data('navTopHeight') + 10);
	// }

	// var sysMainHeight = $targetPage.data('sysMainHeight');
	// console.log('ZZZ sysMainHeight: ' + sysMainHeight);
	// $targetPage.find('.pageMain').height(sysMainHeight*2);

	// $targetPage.find('.pageMain >
	// .contentsPlaceHolder').height(parseInt(sysMainHeight) *2);
	//
	// _.delay(function() {
	// if (!$targetPage.data('mainHeight')) {
	// var components = $targetPage.find('.pageMain').children();
	// var HHH = winHeight - $targetPage.data('navTopHeight'), H = 0;
	// _.each(components, function(c, idx) {
	// var H = $(c).position().top + $(c).outerHeight(false);
	// // console.log('#' + idx + " : " + H);
	// if (H > HHH) {
	// HHH = H;
	// }
	// });
	// console.log('HHH : ' + HHH);
	// $targetPage.data('mainHeight', HHH);
	// }
	// // $ttt.height($targetPage.data('mainHeight') + 5);
	// // $ttt.find('.pageMain').height($targetPage.data('mainHeight') + 10);
	// // $targetPage.height(winHeight);
	// var mainHeight = $targetPage.data('mainHeight');
	// console.log('ZZZ mainHeight: ' + mainHeight);
	// // $targetPage.height(mainHeight+10);
	// $targetPage.find('.pageMain').height(mainHeight);
	// $targetPage.find('.pageMain > .contentsPlaceHolder').height(mainHeight +
	// 20);
	// }, 50);

}

function convertAssetUrl2AndroidEmbedUrl(imageUrl) {
	if (!imageUrl || imageUrl.indexOf('/pic/') !== 0) {
		return '';
	}
	return ANDROID_ASSET_ROOT + imageUrl.substring('/pic'.length + 1).replace('/', '-');
}

function processFonts() {
	_.each(appData.fonts, function(font) {
		var customFont = _.findWhere(allCustomFonts, {
			'family' : font.family
		});
		if (customFont) {
			_.extend(font, customFont);
		} else {
			_.extend(font, FONT_ANDROID_SYSTEM);
		}
		if (!font.system) {
			font.file = ANDROID_ASSET_ROOT + font.file.substring('/static/'.length).replace(/\//g, '-');
			$('head').append(fontCssTemplate(font));
		}
		if (font.isDefault) {
			if (!font.system) {
				$('head').append(fontCssTemplate(_.extend({}, font, {
					'family' : DEFAULT_APP_FONT_FAMILY
				})));
			}
			$('body').css({
				'font-family' : font.family
			});
		}
	});
}