//window.alert = function() {
//};

var initData = {};
var assetUrlRoot;
var baseFileDirUrl, baseApkDownloadDir;

var $appArea;
var quitInd = 0;

var screenId = 0; // 0:adList, 1:adDetail, 2:progress, 3:screenshot-details

var currentAd;
var adFileTransfer;
var fullApkUrl;
var apkDownloadPath;
var adShowTime = 10;

var loadingImgSrcNum = 8;
var loadingTextArray = [ '加载中', '启动中', '努力加载中', '请稍等' ];

var MATRIX = {};
MATRIX.init = function($) {

	$(document).ready(function() {

		$.Mustache.addFromDom();
		var loadingInfoData = {
			imgSrc : Math.floor(Math.random() * loadingImgSrcNum),
			textMessage : loadingTextArray[Math.floor(Math.random() * loadingTextArray.length)],
			styleMarginTop : Math.floor(Math.random() * 30),
			styleColor : '#' + Math.floor(Math.random() * 16777215).toString(16),
			styleFontSize : 12 + Math.floor(Math.random() * 12)
		};
		console.log(loadingInfoData.styleMarginTop + "|" + loadingInfoData.styleFontSize);
		$('.loading').mustache('loading-template', loadingInfoData);

		baseFileDirUrl = cordova.file.dataDirectory;

		baseApkDownloadDir = cordova.file.externalApplicationStorageDirectory;
		if (!baseApkDownloadDir) {
			baseApkDownloadDir = 'sdcard/';
		}

		$appArea = $("#appArea");

		document.addEventListener("backbutton", function() {

			if (screenId == 3) {
				closeScreenshotDetails();
			} else if (screenId == 2) {
				confirmAdDownloadCancellation();
			} else if (screenId == 1) {
				goBackAdList();
			} else if (quitInd == 2) {
				// app exit was already triggered, simply do nothing
			} else if (quitInd == 1) {
				quitInd = 2;
				exitApp();
			} else {
				quitInd = 1;
				window.plugins.toast.show('再按一次后退键确定退出...', 'short', 'bottom');
				setTimeout(function() {
					quitInd = 0;
				},
				// this is according to source code from android SDK, 'short mode' is 2
				// seconds
				// private static final int LONG_DELAY = 3500; // 3.5 seconds
				// private static final int SHORT_DELAY = 2000; // 2 seconds
				2000);
			}

			return false;
		}, false);

		service.call('init', null, function(result) {

			// console.log('init result: ' + JSON.stringify(result));
			initData = _.extend(result, {
				baseVersion : parseInt(result.baseVersion),
				matrixVersion : parseInt(result.matrixVersion),
				appVersion : parseInt(result.appVersion)
			});
			if (result.deviceInfo) {
				initData.deviceInfo = _.extend(result.deviceInfo, {
					"screenSize" : parseFloat(result.deviceInfo.screenSize),
					"screenHeight" : parseInt(result.deviceInfo.screenHeight),
					"screenWidth" : parseInt(result.deviceInfo.screenWidth),
					"sdk" : parseInt(result.deviceInfo.sdk)
				});
			}
			if (!result.deviceId) {
				initData.activated = false;
				activateDevice();
			} else {

				// decode info to check ad activation
				var pair = result.deviceId.split(':');
				if (pair.length >= 2) {

					initData.deviceId = pair[0];
					var activationInfo = pair[1];
					if (activationInfo === 'true') {
						initData.activated = true;
						sendAppOpened();
					} else {

						console.log('---------------restoring activation');
						var adId = pair[2];
						var adApkId = pair[3];
						service.call('getInstalledPackages', 0, function(cordovaResult) {
							var install = _.find(cordovaResult, function(packageInfo) {
								return packageInfo.packageName == activationInfo;
							});
							if (install) {
								// sendAdActivation(adId, adApkId);
								service.call('saveActivation', {
									deviceId : initData.deviceId + ":true"
								}, function(cordovaResult) {
									console.log('---------------------activation is fully restored');
									initData.activated = true;
									sendAppOpened();
								});
							} else {
								initData.activated = false;
								sendAppOpened();
							}
						});
					}
				} else {
					initData.activated = false;
					sendAppOpened();
				}
			}
		});
	});
};

function activateDevice() {

	var url = initData.server + '/v2/service/device/activate';
	var param = initData;
	$.ajax({
		url : url,
		type : 'POST',
		data : param,
		dataType : 'json',
		cache : false,
		success : function(serviceResult) {
			// console.log('activateDevice success. ' + JSON.stringify(serviceResult)
			// + '| deviceId=' + serviceResult.deviceId);
			initData.deviceId = serviceResult.deviceId;
			service.call('saveActivation', {
				deviceId : initData.deviceId
			});
			handleServiceResult(serviceResult);
		},
		error : function(err) {
			// console.log('activateDevice error.' + JSON.stringify(err))
			loadApp(null);
		},
		async : true
	});
}

function sendAppOpened() {

	var url = initData.server + '/v2/service/app/open';
	$.ajax({
		url : url,
		type : 'POST',
		data : {
			appId : initData.appId,
			deviceId : initData.deviceId,
			activated : initData.activated,
			channelId : initData.channelId,
			baseVersion : initData.baseVersion,
			matrixVersion : initData.matrixVersion,
			appVersion : initData.appVersion
		},
		dataType : 'json',
		cache : false,
		success : function(serviceResult) {
			// console.log('sendAppOpened success. ' + JSON.stringify(serviceResult));
			handleServiceResult(serviceResult);
		},
		error : function(err) {
			// console.log('sendAppOpened error.' + JSON.stringify(err))
			loadApp(null);
		},
		async : true,
	});
}

function handleServiceResult(serviceResult) {
	if (!serviceResult.success) {
		loadApp(null);
	}

	if (serviceResult.assetUrlRoot) {
		assetUrlRoot = serviceResult.assetUrlRoot;
	}

	// check matrix update for none market-auditor/free access
	if (serviceResult.needMatrixUpdate && !serviceResult.free) {
		var fileTransfer = new FileTransfer();
		// alert("About to download latest matrix - " + serviceResult.matrixUrl);
		var upgradeSavePath = baseFileDirUrl + "upgrade/"
				+ serviceResult.matrixUrl.substring(serviceResult.matrixUrl.lastIndexOf("/") + 1);
		fileTransfer.download(serviceResult.matrixUrl, upgradeSavePath, function(entry) {
			// alert("Success!" + new Date() + "|entry=" + JSON.stringify(entry));
			service.call('updateMatrix', {
				upgradeSavePath : upgradeSavePath,
				matrixVersion : serviceResult.matrixVersion
			}, function(cordovaResult) {
				// alert('matrix update completed: ' + JSON.stringify(cordovaResult));
				initData.matrixVersion = serviceResult.matrixVersion;
				reloadMatrix();
			});
		}, function(err) {
			loadApp(serviceResult);
		});
	} else if (serviceResult.needAppUpdate && !serviceResult.free) {
		navigator.notification.confirm('新的游戏更新准备好了。要下载安装吗？', function(idx) {
			// APP download progress bar
			if (1 == idx) {
				var fileTransfer = new FileTransfer();
				// alert("About to download latest app - " + serviceResult.appUrl);
				var upgradeSavePath = baseFileDirUrl + "upgrade/"
						+ serviceResult.appUrl.substring(serviceResult.appUrl.lastIndexOf("/") + 1);
				fileTransfer.download(serviceResult.appUrl, upgradeSavePath, function(entry) {
					// alert("Success!" + new Date() + "|entry=" + JSON.stringify(entry));
					service.call('updateApp', {
						upgradeSavePath : upgradeSavePath,
						appVersion : serviceResult.appVersion
					}, function(cordovaResult) {
						loadApp(serviceResult);
					});
				}, function(err) {
					loadApp(serviceResult);
				});
			} else {
				loadApp(serviceResult);
			}
		}, '更新', [ '好的', '下次再说' ]);
	} else {
		loadApp(serviceResult);
	}
}

function reloadMatrix() {
	window.location.replace(baseFileDirUrl + "matrix/" + initData.matrixVersion + "/index.html");
}

function loadApp(serviceResult) {

	$(".loading").hide();

	$appArea.attr('class', 'appAreaDisplay');
	$appArea.attr('frameborder', '0');
	$appArea.attr('seamless', 'seamless');

	if (null != serviceResult) {
		$appArea.load(function() {
			loadAdList(serviceResult);
		});
	}

	$appArea.attr('src', "../../app/" + initData.appVersion + "/index.html");
}

function loadAdList(serviceResult) {

	if (initData.activated || !serviceResult) {
		// console.log('skip AD for already activated device or failed remote
		// request');
		return;
	}

	var effectiveAdList = serviceResult.adList;
	adShowTime = serviceResult.adShowTime;
	if (!effectiveAdList || effectiveAdList.length == 0)
		return;

	service.call('getInstalledPackages', 0, function(cordovaResult) {
		for (var i = effectiveAdList.length - 1; i >= 0; i--) {
			var install = _.find(cordovaResult, function(packageInfo) {
				return packageInfo.packageName == effectiveAdList[i].apkPackageName;
			});
			if (install != null) {
				effectiveAdList.splice(i, 1);
			}
		}
		if (effectiveAdList.length == 0)
			return;

		screenId = 1;
		var $adMask = $('.adMask');
		$adMask.show();

		var $adList = $('.adList');
		var data = _.extend(serviceResult, {
			appName : initData.appName,
			fullIconUrl : function() {
				return assetUrlRoot + '/' + this.iconUrl;
			},
			userFriendlyFileSize : function() {
				return humanize(this.apkSize);
			}
		});
		_.each(effectiveAdList, function(ad, idx) {
			ad.idx = idx;
		});
		$adList.mustache('ad-list-template', data);

		$('.adListTableInner').on('tapone', function(event) {
			loadAdDetail(effectiveAdList[$(event.target).data('idx')]);
		});
		$('.adListDownloadButton').on('tapone', function(event, customObj) {
			customObj.originalEvent.stopPropagation();
			startAdDownload(effectiveAdList[$(event.target).data('idx')]);
		});
		var winWidth = $(window).width();
		var winHeight = $(window).height();
		// alert("winWidth="+winWidth+"|winHeight="+winHeight);
		// alert("window.innerWidth="+window.innerWidth+"|window.innerHeight="+window.innerHeight);
		var width, height;
		if (winWidth > winHeight) {
			width = winWidth * 0.618;
			height = winHeight - 20;
		} else {
			width = winWidth - 20;
			height = winHeight * 0.7;
		}
		$adList.css('top', (winHeight - height) / 2);
		$adList.css('left', (winWidth - width) / 2);
		$adList.height(height);
		$adList.width(width);
		$('.adListBody').height(height - 70);
		touchScroll('adListBody');
		$adList.show();
	});
}

function loadAdDetail(ad) {

	screenId = 1;

	$('.adList').hide();

	var $adDetail = $('.adDetail');
	var data = _.extend(ad, {
		fullScreenshotUrl : function() {
			return assetUrlRoot + '/' + this;
		},
		fullIconUrl : function() {
			return assetUrlRoot + '/' + this.iconUrl;
		},
		userFriendlyFileSize : function() {
			return humanize(this.apkSize);
		}
	});
	$adDetail.mustache('ad-detail-template', data, {
		method : 'html'
	});

	$('.adDetailDownloadButton').on('tapone', function(event, customObj) {
		startAdDownload(ad);
	});
	$('.back2AdList').on('tapone', function(event) {
		goBackAdList();
	});
	var winWidth = $(window).width();
	var winHeight = $(window).height();
	var width = 340, height = 340;
	$adDetail.css('top', (winHeight - height) / 2);
	$adDetail.css('left', (winWidth - width) / 2);
	$adDetail.height(height);
	$adDetail.width(width);
	$('.adDetailBody').width(width);
	$('.adDetailScreenshotList').width(width);
	$('.adDetailScreenshotList').height(height - 160);
	touchScroll('adDetailScreenshotList');

	$('.adDetailScreenshot').on('tapone', function(event) {
		openScreenshotDetails($(event.target).attr('src'));
	});

	$adDetail.show();
}

function openScreenshotDetails(screenshotUrl) {

	var $screenshotDetails = $('.screenshotDetails');
	$screenshotDetails.attr('src', screenshotUrl);

	var r = 400 / 240; // h/w ratio of normal screenshot images
	var winWidth = $(window).width();
	var winHeight = $(window).height();
	if (winWidth > winHeight) {
		$screenshotDetails.height(winHeight);
		$screenshotDetails.width('auto');
		$screenshotDetails.css('top', 0);
		$screenshotDetails.css('left', (winWidth - winHeight / r) / 2);
	} else {
		$screenshotDetails.height('auto');
		$screenshotDetails.width(winWidth);
		$screenshotDetails.css('top', (winHeight - winWidth * r) / 2);
		$screenshotDetails.css('left', 0);
	}
	$screenshotDetails.show();

	$screenshotDetails.on('tapone', function(event, customObj) {
		closeScreenshotDetails();
	});
	screenId = 3;
}

function closeScreenshotDetails() {
	var $screenshotDetails = $('.screenshotDetails');
	$screenshotDetails.hide();
	screenId = 1;
}

function startAdDownload(ad) {

	screenId = 2;
	$('.adList').hide();
	$('.adDetail').hide();

	var $adProgress = $('.adProgress');
	$adProgress.mustache('ad-progress-template', ad, {
		method : 'html'
	});

	$('.adProgressCloseBtn').on('tapone', function(event, customObj) {
		confirmAdDownloadCancellation();
	});
	var winWidth = $(window).width();
	var winHeight = $(window).height();
	var width, height = 90;
	if (winWidth > winHeight) {
		width = winWidth * 0.618;
	} else {
		width = winWidth - 20;
	}
	$adProgress.css('top', (winHeight - height) / 2);
	$adProgress.css('left', (winWidth - width) / 2);
	$adProgress.height(height);
	$adProgress.width(width);
	$adProgress.show();

	currentAd = ad;
	fullApkUrl = assetUrlRoot + '/' + ad.apkUrl;

	adFileTransfer = new FileTransfer();
	apkDownloadPath = baseApkDownloadDir + ad.apkUrl.substring(ad.apkUrl.lastIndexOf("/") + 1);
	adFileTransfer.onprogress = function(progressEvent) {
		if (progressEvent.lengthComputable) {
			var percent = Math.floor(progressEvent.loaded / progressEvent.total * 100) + '%';
			$('.adProgressBar').width(percent);
			$('.adProgressBarText').text(percent);
			// console.log(percent);
		}
	};
	doAdDownload();
}

function doAdDownload() {
	adFileTransfer.download(fullApkUrl, apkDownloadPath, openApkHandler, function(error) {
		// console.log("ad download error:" + JSON.stringify(error));
		if (FileTransferError.ABORT_ERR !== error.code) {
			navigator.notification.confirm('请确保您的网络连接正常。要再试一次吗？', function(idx) {
				if (1 == idx) {
					// XXX 断点续传
					$('.adProgressBar').width('1%');
					$('.adProgressBarText').text('1%');
					doAdDownload();
				} else {
					$('.adProgress').hide();
					$('.adList').show();
					screenId = 0;
				}
			}, '网络故障', [ '好的，再试一次', '不，我要换一个' ]);
		}
	}, true);
}

function openApkHandler() {
	// send ad-activation right away
	sendAdActivation(currentAd.id, currentAd.apkId);
	// record AD packageName in case app is put to backend/killed after ad
	// installation
	service.call('saveActivation', {
		deviceId : initData.deviceId + ":" + currentAd.apkPackageName + ":" + currentAd.id + ":" + currentAd.apkId
	}, function(cordovaResult) {
		var param;
		if (initData.baseVersion <= 0.1) {
			param = apkDownloadPath;
		} else {
			param = {
				'apkDownloadPath' : apkDownloadPath,
				'apkPackageName' : currentAd.apkPackageName,
				'adShowTime' : adShowTime
			};
		}
		service.call('openApk', param, function(cordovaResult) {
			$('.adProgress').hide();
			screenId = 0;
			openAdPendingDialog();
		});
	});
}

function openAdPendingDialog() {
	navigator.notification.confirm("请选择安装试用结果：", function(idx) {
		if (1 == idx) {
			service.call('getInstalledPackages', 0, function(cordovaResult) {
				var install = _.find(cordovaResult, function(packageInfo) {
					return packageInfo.packageName == currentAd.apkPackageName;
				});
				if (install != null) {
					navigator.notification.alert("马上进入应用！", function() {
						var $adMask = $('.adMask');
						$adMask.hide();
					}, '恭喜，激活成功！');
					service.call('saveActivation', {
						deviceId : initData.deviceId + ":true"
					});
				} else {
					openAdInstallFailureDialog();
				}
			});
		} else if (2 == idx) {
			$('.adList').show();
		} else {
			openAdPendingDialog();
		}
	}, '确认安装试用结果', [ '我完成安装试用啦！', '我要换一个' ]);
}

function sendAdActivation(adId, adApkId) {
	var url = initData.server + '/v2/service/ad/activate';
	var param = {
		appId : initData.appId,
		deviceId : initData.deviceId,
		channelId : initData.channelId,
		adId : adId,
		adApkId : adApkId,
		baseVersion : initData.baseVersion,
		matrixVersion : initData.matrixVersion,
		appVersion : initData.appVersion
	};
	$.ajax({
		url : url,
		type : 'POST',
		data : param,
		dataType : 'json',
		cache : false,
		async : true
	});
}

function openAdInstallFailureDialog() {
	navigator.notification.confirm("当前安装尚未结束。请确保您跟随向导完成安装，并打开试用。", function(idx) {
		if (1 == idx) {
			openApkHandler();
		} else if (2 == idx) {
			$('.adList').show();
		} else {
			openAdInstallFailureDialog();
		}
	}, '安装失败:', [ '重新安装', '换一个' ]);
}

function goBackAdList() {
	$('.adDetail').hide();
	$('.adList').show();
	screenId = 0;
}

function confirmAdDownloadCancellation() {
	navigator.notification.confirm('您确定要退出下载吗？请查看您的网络连接通畅以确保快速顺利的下载安装。', function(idx) {
		if (2 == idx) {
			if (adFileTransfer) {
				adFileTransfer.abort();
			}
			$('.adProgress').hide();
			$('.adList').show();
			screenId = 0;
		}
	}, '确认退出下载', [ '不，再等一会儿吧！', '是的，我要换一个' ]);
}

function suspendApp() {
	if ($appArea[0].contentWindow.cr_setSuspended) {
		$appArea[0].contentWindow.cr_setSuspended(1);
	}
}

function resumeApp() {
	if ($appArea[0].contentWindow.cr_setSuspended) {
		$appArea[0].contentWindow.cr_setSuspended(0);
	}
}

function exitApp() {
	var url = initData.server + '/v2/service/app/exit';
	$.ajax({
		url : url,
		type : 'POST',
		data : {
			appId : initData.appId,
			channelId : initData.channelId,
			deviceId : initData.deviceId,
			baseVersion : initData.baseVersion,
			matrixVersion : initData.matrixVersion,
			appVersion : initData.appVersion
		},
		dataType : 'json',
		complete : function() {
			suspendApp();
			navigator.app.exitApp();
		},
		cache : false
	});
}

function launchLwpSettings() {
	service.call('launchLwpSettings', null, function() {
		console.log("ok");
	}, function(err) {
		console.log("error");
	});
}

var humanize = function(size) {
	var gb = Math.pow(1024, 3);
	var mb = Math.pow(1024, 2);
	var kb = 1024;

	if (size >= gb)
		return Math.floor(size / gb) + ' GB';
	else if (size >= mb)
		return Math.floor(size / mb) + ' MB';
	else if (size >= kb)
		return Math.floor(size / kb) + ' KB';
	else
		return size + ' Bytes';
};
